program interpolating_LandFlux

USE read_mod, ONLY : read_variable

implicit none
integer :: i,j,iind,l
integer,parameter :: nx=176,ny=118,nlp=6604
real, dimension(nx,ny) :: missing,lat0,lon0,weight
real, dimension(nlp) :: lat, lon
integer, dimension(nx,ny) :: ind
character(LEN=200) :: filename
character(LEN=9) :: varname
real, allocatable :: vardata(:,:,:)

lat0(:,1)=-25.25
do j=2,ny
lat0(:,j)=lat0(:,j-1)+0.5
enddo
lon0(1,:)=-119.75
do i=2,nx
lon0(i,:)=lon0(i-1,:)+0.5
enddo

filename='/users/global/albmar/utilities/grads/pdef/making_pdef_files/test.annual_Robin.nc' 
varname='latitude'
CALL read_variable(varname,filename,vardata)
print*, SHAPE(vardata)
lat(:)=vardata(:,1,1)
varname='longitude'
if (ALLOCATED(vardata)) DEALLOCATE(vardata)
CALL read_variable(varname,filename,vardata)
print*, SHAPE(vardata)
lon(:)=vardata(:,1,1)

!open(11,file='points_lat_lon.txt')
!do l=1,nlp
!read(11,*) lat(l),lon(l)
!enddo

missing=-999
ind=-999
iind=1
do l=1,nlp
print*,l,lat(l),lon(l)
do i=1,nx
do j=1,ny
if(lat(l).eq.lat0(i,j).and.lon(l).eq.lon0(i,j))then
ind(i,j)=iind
iind=iind+1
weight(i,j)=1
print*,ind(i,j),i,j,l
endif
enddo
enddo
enddo

open(12,file='Robin_pdef_jasmin_2.gra',form='unformatted',convert='little_endian',access='direct',recl=4*nx*ny)
write(12,rec=1) ((ind(i,j),i=1,nx),j=1,ny)
write(12,rec=2) ((weight(i,j),i=1,nx),j=1,ny)
write(12,rec=3) ((missing(i,j),i=1,nx),j=1,ny)
close(12)

endprogram
